import Hero from "./Hero";

const { ccclass, property } = cc._decorator;

@ccclass
export default class Helloworld extends cc.Component {

    @property(cc.Prefab)
    heroPrefab: cc.Prefab[] = [];

    @property(cc.Node)
    heroParentNode: cc.Node = null;

    @property(cc.Label)
    lab: cc.Label = null;
    @property(cc.Label)
    time: cc.Label = null;

    private count: number = 0;
    private _index: number = 0;
    private _date: Date = null;

    onLoad() {
        // 一次性创建数量超过40个就会报下面的异常，批量绘制同时最多40个？
        // Safari 浏览器 WebGL: INVALID_OPERATION: drawElements: request out of bounds for current ELEMENT_ARRAY_BUFFER
        for (let index = 0; index < 1; index++) {
            this.addHero();
        }

        this._date = new Date();
    }

    public addHero() {
        if (this.heroPrefab == null) return;

        let prefab = this.heroPrefab[this._index++];
        // for (const prefab of this.heroPrefab) {
        let hero = cc.instantiate(prefab);
        let heroComponent = hero.getComponent(Hero);
        heroComponent.diedFunction = (node: cc.Node) => {
            this.removeHero(node);
            this.scheduleOnce(() => {
                this.addHero();
            }, 2);
        }
        this.heroParentNode.addChild(hero);
        this._index %= this.heroPrefab.length;
        this.count++;
        // }

        this.lab.string = this.count.toString();
    }

    lateUpdate() {
        let date = new Date();
        let value = date.getTime() - this._date.getTime();
        this.time.string = Math.floor(value / 1000).toString();
    }

    public removeHero(node: cc.Node) {
        this.count--;
        this.lab.string = this.count.toString();

        node.removeFromParent(true);
    }
}
