const { ccclass, property } = cc._decorator;

@ccclass
export default class Hero extends cc.Component {
    @property(sp.Skeleton)
    role: sp.Skeleton = null;

    @property(sp.Skeleton)
    effect: sp.Skeleton[] = [];

    public set diedFunction(fun: Function) {
        this._diedFunction = fun;
    }

    onLoad() {
        this.initAnimations();
        this.runAction();

        this.initSpineEvent();
        this.scheduleOnce(() => {
            this.runAction(this._diedName);
        }, 10);
    }

    protected initSpineEvent(): void {
        // 添加spine帧事件
        this.role.setEventListener((trackEntry, event) => {
            var animationName = trackEntry.animation ? trackEntry.animation.name : "";
            // cc.log("[track %s][animation %s] event: %s, %s, %s, %s", trackEntry.trackIndex, animationName, event.data.name, event.intValue, event.floatValue, event.stringValue);


            // if (animationName) {
            //     if (this.isAttackActionName(animationName)) {
            // if (this._model.isMeleeAttack()) {

            //     this._model.calcAttackHurtBySpineTrackEntry(new SpineTrackEntry(event.data.name, event.intValue, event.floatValue, event.stringValue));
            // } else {
            //     this.shootBullet();
            // }
            //     }
            // }
        });

        // 添加每个spine动作循环中动作每个回合结束时事件
        this.role.setCompleteListener((trackEntry, loopCount) => {
            var animationName = trackEntry.animation ? trackEntry.animation.name : "";
            // if (animationName === 'shoot') {
            //     this.spine.clearTrack(1);
            // }
            // cc.log("[track %s][animation %s] complete: %s", trackEntry.trackIndex, animationName, loopCount);

            if (animationName && animationName == this._curActionName) {
                // switch (animationName) {
                //     // case this._attackName: {
                //     //     this.runAction(this._diedName);
                //     //     break;
                //     // }
                //     case this._diedName: {
                //         if (this._diedFunction) {
                //             this._diedFunction(this.node);
                //             break;
                //         }
                //     }
                //     default: {
                        this.runAction();
                    // }
                // }
                // if ("collapse" == animationName && this._diedFunction) {
                //     this._diedFunction(this.node);
                // } else {
                //     // this.runAction();
                // }
            }
        });

        // 添加spine动作结束事件
        this.role.setEndListener(trackEntry => {
            var animationName = trackEntry.animation ? trackEntry.animation.name : "";
            // cc.log("[track %s][animation %s] end.", trackEntry.trackIndex, animationName);

            // if (animationName) {
            //     this._model.actionEnd(animationName);
            // }
        });
    }

    update(dt: number) {
        // cc.log(`roleview.hitpos()  1`);
        let bone = this.role.findBone("shenti2");
        // cc.log(`roleview.hitpos()  findBone end`);
        if (bone) {
            // cc.log(`roleview.hitpos() bone.worldX:${bone.worldX}, bone.worldY:${bone.worldY}`);
            // bone.updateWorldTransform();
            let point = new cc.Vec2(bone.worldX * this.role.node.scaleX, bone.worldY * this.role.node.scaleY);
            // return this.role.node.convertToWorldSpace(point);
            // point = this.role.node.convertToWorldSpace(point);
            point.addSelf(this.role.node.position);
            point.x *= this.node.scaleX;

            // return this.node.parent.convertToNodeSpace(point);
            // cc.log(`roleview.hitpos()  2-1`);
        } else {
            cc.error(`没有受击点`);
            // cc.log(`roleview.hitpos()  2-2`);
            return null;
        }
    }

    protected runAction(actionName: string = null) {
        if (actionName == null) {
            actionName = this.getActionName();
            if (this._diedName == actionName) {
                actionName = this.getActionName();
            }
        }

        this._curActionName = actionName;
        this.role.setAnimation(0, actionName, true);
        for (const effect of this.effect) {
            effect.setAnimation(0, actionName, true);
        }
    }

    protected getActionName() {
        let actionName = this._animations[this._actionIndex++];
        this._actionIndex %= this._animations.length;
        return actionName;
    }

    protected initAnimations() {
        let animations = this.role.skeletonData.skeletonJson.animations;
        for (const key in animations) {
            if (animations.hasOwnProperty(key)) {
                const element = animations[key];
                if (element) {
                    this._animations.push(key);
                }
            }
        }
    }

    private _animations: string[] = [];
    private _curActionName: string = "";
    private _actionIndex: number = 0;
    private _diedFunction: Function = null;
    private _diedName: string = "collapse";
    private _attackName: string = "hit_1";
}
